"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright (c) 2019-2022 Exabel AS. All rights reserved."""
import builtins
import collections.abc
from ..... import exabel
import google.protobuf.descriptor
import google.protobuf.field_mask_pb2
import google.protobuf.internal.containers
import google.protobuf.message
import typing
DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class CreateTagRequest(google.protobuf.message.Message):
    """Request to CreateTag."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    TAG_FIELD_NUMBER: builtins.int
    FOLDER_FIELD_NUMBER: builtins.int
    folder: builtins.str
    'Resource name of the Library folder to create the signal in, e.g. `folders/123`. If not\n    specified, the signal will be created in an “Analytics API” folder that is shared with the\n    customer user group.\n    '

    @property
    def tag(self) -> exabel.api.analytics.v1.tag_messages_pb2.Tag:
        """A tag"""

    def __init__(self, *, tag: exabel.api.analytics.v1.tag_messages_pb2.Tag | None=..., folder: builtins.str | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['tag', b'tag']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['folder', b'folder', 'tag', b'tag']) -> None:
        ...
global___CreateTagRequest = CreateTagRequest

@typing.final
class GetTagRequest(google.protobuf.message.Message):
    """Request to GetTag."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    name: builtins.str
    'Resource name of the requested tag\n    Example: `tags/user:abc123`.\n    '

    def __init__(self, *, name: builtins.str | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['name', b'name']) -> None:
        ...
global___GetTagRequest = GetTagRequest

@typing.final
class UpdateTagRequest(google.protobuf.message.Message):
    """Request to UpdateTag."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    TAG_FIELD_NUMBER: builtins.int
    UPDATE_MASK_FIELD_NUMBER: builtins.int

    @property
    def tag(self) -> exabel.api.analytics.v1.tag_messages_pb2.Tag:
        """A tag."""

    @property
    def update_mask(self) -> google.protobuf.field_mask_pb2.FieldMask:
        """Use this to update only selected fields. For example, specify `display_name` to update only
        the display name.

        For REST requests, this is a comma-separated string.
        """

    def __init__(self, *, tag: exabel.api.analytics.v1.tag_messages_pb2.Tag | None=..., update_mask: google.protobuf.field_mask_pb2.FieldMask | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['tag', b'tag', 'update_mask', b'update_mask']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['tag', b'tag', 'update_mask', b'update_mask']) -> None:
        ...
global___UpdateTagRequest = UpdateTagRequest

@typing.final
class DeleteTagRequest(google.protobuf.message.Message):
    """Request to DeleteTag."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    name: builtins.str
    'The tag resource name.'

    def __init__(self, *, name: builtins.str | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['name', b'name']) -> None:
        ...
global___DeleteTagRequest = DeleteTagRequest

@typing.final
class ListTagsRequest(google.protobuf.message.Message):
    """Request to list tags."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    PAGE_SIZE_FIELD_NUMBER: builtins.int
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    page_size: builtins.int
    'Maximum number of results to return. Default is 20 and max is 1000.'
    page_token: builtins.str
    'Token for a specific page of results, as returned from a previous list request with the same\n    query parameters.\n    '

    def __init__(self, *, page_size: builtins.int | None=..., page_token: builtins.str | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['page_size', b'page_size', 'page_token', b'page_token']) -> None:
        ...
global___ListTagsRequest = ListTagsRequest

@typing.final
class ListTagsResponse(google.protobuf.message.Message):
    """Response to list tags."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    TAGS_FIELD_NUMBER: builtins.int
    NEXT_PAGE_TOKEN_FIELD_NUMBER: builtins.int
    TOTAL_SIZE_FIELD_NUMBER: builtins.int
    next_page_token: builtins.str
    'Token for the next page of results, which can be sent to a subsequent query.\n    The end of the list is reached when the token is empty.\n    '
    total_size: builtins.int
    'Total number of results, irrespective of paging.'

    @property
    def tags(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[exabel.api.analytics.v1.tag_messages_pb2.Tag]:
        """The tags in the requested page."""

    def __init__(self, *, tags: collections.abc.Iterable[exabel.api.analytics.v1.tag_messages_pb2.Tag] | None=..., next_page_token: builtins.str | None=..., total_size: builtins.int | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['next_page_token', b'next_page_token', 'tags', b'tags', 'total_size', b'total_size']) -> None:
        ...
global___ListTagsResponse = ListTagsResponse

@typing.final
class AddEntitiesRequest(google.protobuf.message.Message):
    """Request to add entities to tag."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    ENTITY_NAMES_FIELD_NUMBER: builtins.int
    name: builtins.str
    'Resource name of the tag to add entities to\n    Example: `tags/user:abc123`.\n    '

    @property
    def entity_names(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """List of entity resource names to add to tag. You may find these resource names with the
        EntityService.
        """

    def __init__(self, *, name: builtins.str | None=..., entity_names: collections.abc.Iterable[builtins.str] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['entity_names', b'entity_names', 'name', b'name']) -> None:
        ...
global___AddEntitiesRequest = AddEntitiesRequest

@typing.final
class AddEntitiesResponse(google.protobuf.message.Message):
    """Response to add entities to a tag"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(self) -> None:
        ...
global___AddEntitiesResponse = AddEntitiesResponse

@typing.final
class RemoveEntitiesRequest(google.protobuf.message.Message):
    """Request to remove entities from a tag."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    ENTITY_NAMES_FIELD_NUMBER: builtins.int
    name: builtins.str
    'Resource name of the tag to remove entities from\n    Example: `tags/user:abc123`.\n    '

    @property
    def entity_names(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """List of entity resource names to remove from tag."""

    def __init__(self, *, name: builtins.str | None=..., entity_names: collections.abc.Iterable[builtins.str] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['entity_names', b'entity_names', 'name', b'name']) -> None:
        ...
global___RemoveEntitiesRequest = RemoveEntitiesRequest

@typing.final
class RemoveEntitiesResponse(google.protobuf.message.Message):
    """Response to remove entities from a tag"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(self) -> None:
        ...
global___RemoveEntitiesResponse = RemoveEntitiesResponse

@typing.final
class ListTagEntitiesRequest(google.protobuf.message.Message):
    """Request to list entities in a tag."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    PARENT_FIELD_NUMBER: builtins.int
    PAGE_SIZE_FIELD_NUMBER: builtins.int
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    parent: builtins.str
    'The parent tag to list entities for\n    Example: `tags/user:abc123`.\n    '
    page_size: builtins.int
    'Maximum number of results to return. Default is 20 and max is 1000.'
    page_token: builtins.str
    'Token for a specific page of results, as returned from a previous list request with the same\n    query parameters.\n    '

    def __init__(self, *, parent: builtins.str | None=..., page_size: builtins.int | None=..., page_token: builtins.str | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['page_size', b'page_size', 'page_token', b'page_token', 'parent', b'parent']) -> None:
        ...
global___ListTagEntitiesRequest = ListTagEntitiesRequest

@typing.final
class ListTagEntitiesResponse(google.protobuf.message.Message):
    """Response to list entities in a tag."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    ENTITY_NAMES_FIELD_NUMBER: builtins.int
    NEXT_PAGE_TOKEN_FIELD_NUMBER: builtins.int
    TOTAL_SIZE_FIELD_NUMBER: builtins.int
    next_page_token: builtins.str
    'Token for the next page of results, which can be sent to a subsequent query.\n    The end of the list is reached when the token is empty.\n    '
    total_size: builtins.int
    'Total number of results, irrespective of paging.'

    @property
    def entity_names(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """List of entity resource names."""

    def __init__(self, *, entity_names: collections.abc.Iterable[builtins.str] | None=..., next_page_token: builtins.str | None=..., total_size: builtins.int | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['entity_names', b'entity_names', 'next_page_token', b'next_page_token', 'total_size', b'total_size']) -> None:
        ...
global___ListTagEntitiesResponse = ListTagEntitiesResponse