"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright (c) 2019-2024 Exabel AS. All rights reserved."""
import builtins
import collections.abc
from ..... import exabel
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import typing
DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class Signal(google.protobuf.message.Message):
    """A signal resource in the Data API. Signals are normally associated with a set of entity types,
    but may apply to any entities.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    ENTITY_TYPE_FIELD_NUMBER: builtins.int
    DISPLAY_NAME_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    DOWNSAMPLING_METHOD_FIELD_NUMBER: builtins.int
    READ_ONLY_FIELD_NUMBER: builtins.int
    ENTITY_TYPES_FIELD_NUMBER: builtins.int
    name: builtins.str
    'Unique resource name of the raw data signal, e.g. `signals/signalIdentifier` or\n    `signals/namespace.signalIdentifier`. The namespace must be empty (being global) or a\n    namespace accessible to the customer.\n    The signal identifier must match the regex `[a-zA-Z]\\w{0,127}`.\n    '
    entity_type: builtins.str
    'No longer in use.'
    display_name: builtins.str
    'Used when showing the signal in the Exabel app. Required when creating a signal.'
    description: builtins.str
    'Used when showing the signal in the Exabel app.'
    downsampling_method: exabel.api.math.aggregation_pb2.Aggregation.ValueType
    'The default downsampling method to use when this signal is re-sampled into larger intervals.\n    When two or more values in an interval needs to be aggregated into a single value, specifies\n    how they are combined.\n    '
    read_only: builtins.bool
    'Global signals and those from data sets that you subscribe to will be read-only.'

    @property
    def entity_types(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """List of entity types that this signal has time series for, e.g.
        `entityTypes/ns.type1`, `entityTypes/ns.type2`.
        """

    def __init__(self, *, name: builtins.str | None=..., entity_type: builtins.str | None=..., display_name: builtins.str | None=..., description: builtins.str | None=..., downsampling_method: exabel.api.math.aggregation_pb2.Aggregation.ValueType | None=..., read_only: builtins.bool | None=..., entity_types: collections.abc.Iterable[builtins.str] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['description', b'description', 'display_name', b'display_name', 'downsampling_method', b'downsampling_method', 'entity_type', b'entity_type', 'entity_types', b'entity_types', 'name', b'name', 'read_only', b'read_only']) -> None:
        ...
global___Signal = Signal

@typing.final
class DerivedSignal(google.protobuf.message.Message):
    """A derived signal resource in the Data API. A derived signal is part of one data set and can be
    added or removed using the `derived_signals` field of `UpdateDataSet`. It cannot be edited
    through the Data API; it must be edited in the library.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    DATA_SETS_FIELD_NUMBER: builtins.int
    DISPLAY_NAME_FIELD_NUMBER: builtins.int
    LABEL_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    EXPRESSION_FIELD_NUMBER: builtins.int
    DOWNSAMPLING_METHOD_FIELD_NUMBER: builtins.int
    CHANGE_FIELD_NUMBER: builtins.int
    ENTITY_SET_FIELD_NUMBER: builtins.int
    HIGHLIGHTED_FIELD_NUMBER: builtins.int
    name: builtins.str
    "Unique resource name of the derived signal, e.g. `derivedSignals/signalIdentifier`. Derived\n    signals don't have namespaces in their resource names. The signal identifier must be numeric.\n    "
    display_name: builtins.str
    'The display name of the signal.'
    label: builtins.str
    'The label of the signal.'
    description: builtins.str
    'The description of the signal.'
    expression: builtins.str
    'The signal expression.'
    downsampling_method: exabel.api.math.aggregation_pb2.Aggregation.ValueType
    'The default downsampling method to use when this signal is re-sampled into larger intervals.\n    When two or more values in an interval needs to be aggregated into a single value, specifies\n    how they are combined.\n    '
    change: exabel.api.math.change_pb2.Change.ValueType
    'The method used to calculate changes in this signal.'
    highlighted: builtins.bool
    'Whether this derived signal is highlighted (inside a specific data set).'

    @property
    def data_sets(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """The data set(s) this derived signal belongs to."""

    @property
    def entity_set(self) -> exabel.api.data.v1.common_messages_pb2.EntitySet:
        """The set of entities that this derived signal is valid for."""

    def __init__(self, *, name: builtins.str | None=..., data_sets: collections.abc.Iterable[builtins.str] | None=..., display_name: builtins.str | None=..., label: builtins.str | None=..., description: builtins.str | None=..., expression: builtins.str | None=..., downsampling_method: exabel.api.math.aggregation_pb2.Aggregation.ValueType | None=..., change: exabel.api.math.change_pb2.Change.ValueType | None=..., entity_set: exabel.api.data.v1.common_messages_pb2.EntitySet | None=..., highlighted: builtins.bool | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['entity_set', b'entity_set']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['change', b'change', 'data_sets', b'data_sets', 'description', b'description', 'display_name', b'display_name', 'downsampling_method', b'downsampling_method', 'entity_set', b'entity_set', 'expression', b'expression', 'highlighted', b'highlighted', 'label', b'label', 'name', b'name']) -> None:
        ...
global___DerivedSignal = DerivedSignal

@typing.final
class DerivedSignals(google.protobuf.message.Message):
    """A list of signals."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    DERIVED_SIGNALS_FIELD_NUMBER: builtins.int

    @property
    def derived_signals(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___DerivedSignal]:
        """The list of signals."""

    def __init__(self, *, derived_signals: collections.abc.Iterable[global___DerivedSignal] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['derived_signals', b'derived_signals']) -> None:
        ...
global___DerivedSignals = DerivedSignals